Index: trunk/source/processes/electromagnetic/standard/src/G4GoudsmitSaundersonMscModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4GoudsmitSaundersonMscModel.cc	(revision 1058)
+++ trunk/source/processes/electromagnetic/standard/src/G4GoudsmitSaundersonMscModel.cc	(revision 1196)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4GoudsmitSaundersonMscModel.cc,v 1.7 2009/04/20 19:22:29 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+// $Id: G4GoudsmitSaundersonMscModel.cc,v 1.19 2009/11/09 18:40:25 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -44,6 +44,14 @@
 //                     step into two sub-steps occur only for msc regime
 //
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
+// 12.06.2009 O.Kadri: linear log-log extrapolation of lambda0 & lambda1 between 1 GeV - 100 TeV
+//                     adding a theta min limit due to screening effect of the atomic nucleus
+// 26.08.2009 O.Kadri: Cubic Spline interpolation was replaced with polynomial method
+//                     within CalculateIntegrals method
+// 05.10.2009 O.Kadri: tuning small angle theta distributions
+//                     assuming the case of lambdan<1 as single scattering regime
+//                     tuning theta sampling for theta below the screening angle
+//
+//
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo...... 
 //REFERENCES:
 //Ref.1:E. Benedito et al.,"Mixed simulation ... cross-sections", NIMB 174 (2001) pp 91-110;
@@ -62,5 +70,4 @@
 #include "G4MaterialCutsCouple.hh"
 #include "G4DynamicParticle.hh"
-#include "G4DataInterpolation.hh" 
 #include "G4Electron.hh"
 #include "G4Positron.hh"
@@ -82,7 +89,7 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
 G4GoudsmitSaundersonMscModel::G4GoudsmitSaundersonMscModel(const G4String& nam)
-  : G4VMscModel(nam),lowKEnergy(0.1*keV),highKEnergy(GeV),isInitialized(false)
+  : G4VMscModel(nam),lowKEnergy(0.1*keV),highKEnergy(100.*TeV),isInitialized(false)
 { 
-  fr=0.02,rangeinit=0.,masslimite=0.6*MeV;
+  fr=0.02,rangeinit=0.,masslimite=0.6*MeV,
   particle=0;tausmall=1.e-16;taulim=1.e-6;tlimit=1.e10*mm;
   tlimitmin=10.e-6*mm;geombig=1.e50*mm;geommin=1.e-3*mm,tgeom=geombig;
@@ -117,6 +124,7 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
 
-G4double G4GoudsmitSaundersonMscModel::ComputeCrossSectionPerAtom(const G4ParticleDefinition* p,
-                          G4double kineticEnergy,G4double Z, G4double, G4double, G4double)
+G4double 
+G4GoudsmitSaundersonMscModel::ComputeCrossSectionPerAtom(const G4ParticleDefinition* p,
+                       G4double kineticEnergy,G4double Z, G4double, G4double, G4double)
 {  
   //Build cross section table : Taken from Ref.7
@@ -126,5 +134,4 @@
   if(kinEnergy>highKEnergy)kinEnergy=highKEnergy;
 
-  //value0=Lambda0;value1=Lambda1
   G4double value0,value1;
   CalculateIntegrals(p,Z,kinEnergy,value0,value1);
@@ -136,6 +143,7 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
 
-void G4GoudsmitSaundersonMscModel::SampleScattering(const G4DynamicParticle* dynParticle,
-				       G4double safety)
+void 
+G4GoudsmitSaundersonMscModel::SampleScattering(const G4DynamicParticle* dynParticle,
+					       G4double safety)
 {    
   G4double kineticEnergy = dynParticle->GetKineticEnergy();
@@ -144,21 +152,19 @@
   G4double cosTheta1,sinTheta1,cosTheta2,sinTheta2;
   G4double phi1,phi2,cosPhi1=1.0,sinPhi1=0.0,cosPhi2=1.0,sinPhi2=0.0;
-  G4double q1,Gamma,Eta,delta,nu,nu0,nu1,nu2,nu_interm;
+  G4double q1,Gamma,Eta,delta,nu,nu0,nu1,nu2;
 
   ///////////////////////////////////////////
   // Effective energy and path-length from Eq. 4.7.15+16 of Ref.4
   G4double  eloss = theManager->GetEnergy(particle,tPathLength,currentCouple);
-  if(eloss>0.5*kineticEnergy)return;
+  if(eloss>0.5*kineticEnergy)eloss=kineticEnergy-eloss;//exchange possibility between target atomic e- and incident particle
   G4double ee       = kineticEnergy - 0.5*eloss;
   G4double ttau     = ee/electron_mass_c2;
   G4double ttau2    = ttau*ttau;
   G4double epsilonpp= eloss/ee;
-  G4double temp2  = 0.166666*(4+ttau*(6+ttau*(7+ttau*(4+ttau))))*(epsilonpp/(ttau+1)/(ttau+2))*(epsilonpp/(ttau+1)/(ttau+2));
   G4double cst1=epsilonpp*epsilonpp*(6+10*ttau+5*ttau2)/(24*ttau2+48*ttau+72);
 
   kineticEnergy *= (1 - cst1);
-  tPathLength *= (1 - temp2);
   ///////////////////////////////////////////
-  // additivity rule for mixture xsection calculation
+  // additivity rule for mixture and compound xsection calculation
   const G4Material* mat = currentCouple->GetMaterial();
   G4int nelm = mat->GetNumberOfElements();
@@ -166,6 +172,5 @@
   const G4double* theFraction = mat->GetFractionVector();
   G4double atomPerVolume = mat->GetTotNbOfAtomsPerVolume();
-  G4double scrA,llambda0,llambda1;
-  scrA=0.0;llambda0 =0.;llambda1=0.;
+  G4double llambda0=0.,llambda1=0.;
   for(G4int i=0;i<nelm;i++)
     {
@@ -175,60 +180,72 @@
       llambda1 += (theFraction[i]/l1);
     } 
-  if(llambda0>DBL_MIN)llambda0 =1./llambda0;
-  if(llambda1>DBL_MIN)llambda1 =1./llambda1;
-  G4double g1=llambda0/llambda1;
+  if(llambda0>DBL_MIN) llambda0 =1./llambda0;
+  if(llambda1>DBL_MIN) llambda1 =1./llambda1;
+  G4double g1=0.0;
+  if(llambda1>DBL_MIN) g1 = llambda0/llambda1;
+
   G4double x1,x0;
-
   x0=g1/2.;
   do
     {  
-      x1 = x0-(x0*((1.+x0)*std::log(1.+1./x0)-1.0)-g1/2.)/( (1.+2.*x0)*std::log(1.+1./x0)-2.0);// x1=x0-f(x0)/f'(x0)
+      x1 = x0-(x0*((1.+x0)*log(1.+1./x0)-1.0)-g1/2.)/( (1.+2.*x0)*log(1.+1./x0)-2.0);// x1=x0-f(x0)/f'(x0)
       delta = std::abs( x1 - x0 );    
       x0 = x1;  // new approximation becomes the old approximation for the next iteration
     } while (delta > 1e-10);
-  scrA = x1;
+  G4double scrA = x1;
 
   G4double us=0.0,vs=0.0,ws=1.0,x_coord=0.0,y_coord=0.0,z_coord=1.0;
   G4double lambdan=0.;
+  G4bool mscatt=false,noscatt=false;
+
   if(llambda0>0.)lambdan=atomPerVolume*tPathLength/llambda0;
-  if((lambdan<=1.0e-12)||(lambdan>1.0e+5))return;
-  G4bool noscatt=false;
-  G4bool singlescatt=false;
-  G4bool mscatt=false;
+  if((lambdan<=1.0e-12))return;
 
   G4double epsilon1=G4UniformRand();
-  if(epsilon1<(exp(-lambdan)))noscatt=true;// no scattering     
-  else if(epsilon1<((1.+lambdan)*exp(-lambdan)))//single scattering
-    {singlescatt=true;
-     ws=G4UniformRand();
-     ws= 1.-2.*scrA*ws/(1.-ws + scrA);
-     G4double phi0=twopi*G4UniformRand(); 
-     us=sqrt(1.-ws*ws)*cos(phi0);
-     vs=sqrt(1.-ws*ws)*sin(phi0);
-     G4double rr=G4UniformRand();
-     x_coord=(rr*us);
-     y_coord=(rr*vs);
-     z_coord=((1.-rr)+rr*ws);     
+  G4double expn = exp(-lambdan);
+  if((epsilon1<expn)||insideskin)// no scattering 
+    {noscatt=true;}
+  else if((epsilon1<((1.+lambdan)*expn)||(lambdan<1.)))
+    {
+      mscatt=false;
+      ws=G4UniformRand();
+      ws= 1.-2.*scrA*ws/(1.-ws + scrA);
+      if(acos(ws)<sqrt(scrA))//small angle approximation for theta less than screening angle
+      {G4int i=0;
+      do{i++;
+      ws=1.+0.5*atomPerVolume*tPathLength*log(G4UniformRand())/llambda1;
+      }while((fabs(ws)>1.)&&(i<20));//i<20 to avoid time consuming during the run
+      if(i==19)ws=cos(sqrt(scrA));
+      }
+      G4double phi0=twopi*G4UniformRand(); 
+      us=sqrt(1.-ws*ws)*cos(phi0);
+      vs=sqrt(1.-ws*ws)*sin(phi0);
+      G4double rr=G4UniformRand();
+      x_coord=(rr*us);
+      y_coord=(rr*vs);
+      z_coord=((1.-rr)+rr*ws);
     }
   else
-  {mscatt=true;
-  // Ref.2 subsection 4.4 "The best solution found"
-  // Sample first substep scattering angle
-  SampleCosineTheta(0.5*lambdan,scrA,cosTheta1,sinTheta1);
-  phi1  = twopi*G4UniformRand();
-  cosPhi1 = cos(phi1);
-  sinPhi1 = sin(phi1);
-
-  // Sample second substep scattering angle
-  SampleCosineTheta(0.5*lambdan,scrA,cosTheta2,sinTheta2);
-  phi2  = twopi*G4UniformRand();
-  cosPhi2 = cos(phi2);
-  sinPhi2 = sin(phi2);
-
-  // Scattering direction
-  us = sinTheta2*(cosTheta1*cosPhi1*cosPhi2 - sinPhi1*sinPhi2) + cosTheta2*sinTheta1*cosPhi1;
-  vs = sinTheta2*(cosTheta1*sinPhi1*cosPhi2 + cosPhi1*sinPhi2) + cosTheta2*sinTheta1*sinPhi1;
-  ws = cosTheta1*cosTheta2 - sinTheta1*sinTheta2*cosPhi2; 
-  }
+    {
+      mscatt=true;
+      // Ref.2 subsection 4.4 "The best solution found"
+      // Sample first substep scattering angle
+      SampleCosineTheta(0.5*lambdan,scrA,cosTheta1,sinTheta1);
+      phi1  = twopi*G4UniformRand();
+      cosPhi1 = cos(phi1);
+      sinPhi1 = sin(phi1);
+
+      // Sample second substep scattering angle
+      SampleCosineTheta(0.5*lambdan,scrA,cosTheta2,sinTheta2);
+      phi2  = twopi*G4UniformRand();
+      cosPhi2 = cos(phi2);
+      sinPhi2 = sin(phi2);
+
+      // Scattering direction
+      us = sinTheta2*(cosTheta1*cosPhi1*cosPhi2 - sinPhi1*sinPhi2) + cosTheta2*sinTheta1*cosPhi1;
+      vs = sinTheta2*(cosTheta1*sinPhi1*cosPhi2 + cosPhi1*sinPhi2) + cosTheta2*sinTheta1*sinPhi1;
+      ws = cosTheta1*cosTheta2 - sinTheta1*sinTheta2*cosPhi2; 
+    }
+    
   G4ThreeVector oldDirection = dynParticle->GetMomentumDirection();
   G4ThreeVector newDirection(us,vs,ws);
@@ -238,37 +255,41 @@
   if((safety > tlimitminfix)&&(latDisplasment))
     {  
-      // Scattering coordinates
+
       if(mscatt)
-      {
-      if(scrA<DBL_MIN)scrA=DBL_MIN;
-      q1       = 2.*scrA*((1. + scrA)*log(1. + 1./scrA) - 1.);
-      if(q1<DBL_MIN)q1=DBL_MIN;
-      Gamma    = 6.*scrA*(1. + scrA)*((1. + 2.*scrA)*log(1. + 1./scrA) - 2.)/q1;
-      Eta      = atomPerVolume*tPathLength/llambda1;      
-      delta    = 0.90824829 - Eta*(0.102062073-Gamma*0.026374715);
-
-      nu = G4UniformRand(); 
-      nu = std::sqrt(nu);
-      nu0 = (1.0 - nu)/2.;
-      nu1 = nu*delta;
-      nu2 = nu*(1.0-delta);
-      nu_interm = 1.0 - nu0 - nu1 - nu2; 
-      x_coord=(nu1*sinTheta1*cosPhi1+nu2*sinTheta2*(cosPhi1*cosPhi2-cosTheta1*sinPhi1*sinPhi2)+nu_interm*us);
-      y_coord=(nu1*sinTheta1*sinPhi1+nu2*sinTheta2*(sinPhi1*cosPhi2+cosTheta1*cosPhi1*sinPhi2)+nu_interm*vs);
-      z_coord=(nu0+nu1*cosTheta1+nu2*cosTheta2+ nu_interm*ws)  ;
-      }
-      G4double r=sqrt(x_coord*x_coord+y_coord*y_coord+z_coord*z_coord);
-
-      G4double check= 1.- tPathLength/zPathLength;
-      if(check<=0.)    return;
-      else if(r>check) {r=check;x_coord /=r;y_coord /=r;z_coord /=r;}
-
-      r *=tPathLength;
-      
+	{
+	  if(scrA<DBL_MIN)scrA=DBL_MIN;
+	  if(llambda1<DBL_MIN)llambda1=DBL_MIN;
+	  q1 = 2.*scrA*((1. + scrA)*log(1. + 1./scrA) - 1.);
+	  if(q1<DBL_MIN)q1=DBL_MIN;
+	  Gamma  = 6.*scrA*(1. + scrA)*((1. + 2.*scrA)*log(1. + 1./scrA) - 2.)/q1;
+	  Eta    = atomPerVolume*tPathLength/llambda1;      
+	  delta  = 0.90824829 - Eta*(0.102062073-Gamma*0.026374715);
+
+	  nu = G4UniformRand(); 
+	  nu = std::sqrt(nu);
+	  nu0 = (1.0 - nu)/2.;
+	  nu1 = nu*delta;
+	  nu2 = nu*(1.0-delta);
+	  x_coord=(nu1*sinTheta1*cosPhi1+nu2*sinTheta2*(cosPhi1*cosPhi2-cosTheta1*sinPhi1*sinPhi2)+nu0*us);
+	  y_coord=(nu1*sinTheta1*sinPhi1+nu2*sinTheta2*(sinPhi1*cosPhi2+cosTheta1*cosPhi1*sinPhi2)+nu0*vs);
+	  z_coord=(nu0+nu1*cosTheta1+nu2*cosTheta2+ nu0*ws)  ;
+	}
+
+      // displacement is computed relatively to the end point
+      if(!noscatt)z_coord -= 1.0;//for noscatt zcoord z_coord !=0.
+      G4double rr = sqrt(x_coord*x_coord+y_coord*y_coord+z_coord*z_coord);
+      G4double r  = rr*zPathLength;
+      /*
+      G4cout << "G4GS::SampleSecondaries: e(MeV)= " << kineticEnergy
+	     << " sinTheta= " << sqrt(1.0 - ws*ws) << " r(mm)= " << r
+	     << " trueStep(mm)= " << tPathLength
+	     << " geomStep(mm)= " << zPathLength
+	     << G4endl;
+      */
       if(r > tlimitminfix) {
 
-	G4ThreeVector latDirection = G4ThreeVector(x_coord*tPathLength,y_coord*tPathLength,z_coord*tPathLength);
-	latDirection.rotateUz(oldDirection);
- 
+        G4ThreeVector latDirection(x_coord/rr,y_coord/rr,z_coord/rr);
+        latDirection.rotateUz(oldDirection);
+
 	ComputeDisplacement(fParticleChange, latDirection, r, safety);
       }     
@@ -277,6 +298,8 @@
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
-void G4GoudsmitSaundersonMscModel::SampleCosineTheta(G4double lambdan, G4double scrA,
-						     G4double &cost, G4double &sint)
+
+void 
+G4GoudsmitSaundersonMscModel::SampleCosineTheta(G4double lambdan, G4double scrA,
+						G4double &cost, G4double &sint)
 {
   G4double u,Qn1,r1,tet;
@@ -284,26 +307,16 @@
   Qn1=2.* lambdan *scrA*((1.+scrA)*log(1.+1./scrA)-1.);
 
-  if((lambdan<1.)||(Qn1<0.001))//plural scatt. or small angle scatt.
-	    {
-	      G4double xi1,lambdai=0.;
-	      G4int i=0;
-	      do {xi1=G4UniformRand();
-	      lambdai -=std::log(xi1);
-	      xi +=2.*scrA*xi1/(1.-xi1 + scrA);
-	      i++;
-	      }while((lambdai<lambdan)&&(i<30));
-	    
-	    }
-	  else {
-	    if(Qn1>0.5)xi=2.*G4UniformRand();//isotropic distribution
-	    else{// procedure described by Benedito in Ref.1
-	         do{r1=G4UniformRand();
-	         u=GSTable->SampleTheta(lambdan,scrA,G4UniformRand());
- 	         xi = 2.*u;
-       	         tet=acos(1.-xi);
-                 }while(tet*r1*r1>sin(tet));
-	       } 
-	      }
-
+if (Qn1<0.001)xi=-0.5*Qn1*log(G4UniformRand());
+else if(Qn1>0.5)xi=2.*G4UniformRand();//isotropic distribution
+else
+{
+      // procedure described by Benedito in Ref.1
+      do{
+	r1=G4UniformRand();
+	u=GSTable->SampleTheta(lambdan,scrA,G4UniformRand());
+	xi = 2.*u;
+	tet=acos(1.-xi);
+      }while(tet*r1*r1>sin(tet));
+}
 
   if(xi<0.)xi=0.;
@@ -315,53 +328,97 @@
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
-// Cubic spline log-log interpolation of Lambda0 and Lambda1
-// Screening parameter calculated according to Eq. 37 of Ref.1 
-void G4GoudsmitSaundersonMscModel::CalculateIntegrals(const G4ParticleDefinition* p,G4double Z, 
-						      G4double kinEnergy,G4double &Lam0,
-						      G4double &Lam1)
+// Polynomial log-log interpolation of Lambda0 and Lambda1 between 100 eV - 1 GeV
+// linear log-log extrapolation between 1 GeV - 100 TeV
+
+void 
+G4GoudsmitSaundersonMscModel::CalculateIntegrals(const G4ParticleDefinition* p,G4double Z, 
+						 G4double kinEnergy,G4double &Lam0,
+						 G4double &Lam1)
 { 
-  //////// BEGIN OF: LAMBDA CALCULATION ////////////////////////////////
-  G4double TCSEForThisAtom[106],FTCSEForThisAtom[106],TCSPForThisAtom[106],FTCSPForThisAtom[106];
   G4double summ00=0.0;
   G4double summ10=0.0;
-  G4double InterpolatedValue=0.0;
-  
-  
-  G4int  iZ = G4int(Z);
-  if(iZ > 103) iZ = 103;
-  for(G4int i=0;i<106;i++)
-    {
-      TCSEForThisAtom[i]=TCSE[iZ-1][i];FTCSEForThisAtom[i]=FTCSE[iZ-1][i];
-      TCSPForThisAtom[i]=TCSP[iZ-1][i];FTCSPForThisAtom[i]=FTCSP[iZ-1][i];
-    }
-
+  G4double x1,x2,y1,y2,acoeff,bcoeff;
   G4double kineticE = kinEnergy;
   if(kineticE<lowKEnergy)kineticE=lowKEnergy;
   if(kineticE>highKEnergy)kineticE=highKEnergy;
   kineticE /= eV;
+  G4double logE=log(kineticE);
+  
+  G4int  iZ = G4int(Z);
+  if(iZ > 103) iZ = 103;
+
+  G4int enerInd=0;
+  for(G4int i=1;i<106;i++)
+  {
+  if((logE>=ener[i])&&(logE<ener[i+1])){enerInd=i;break;}
+  }
+
+  if(p==G4Electron::Electron())        
+    {
+    if(kineticE<=1.0e+9)//Interpolation of the form y=ax²+b
+      {
+	x1=ener[enerInd];
+	x2=ener[enerInd+1];       
+	y1=TCSE[iZ-1][enerInd];
+	y2=TCSE[iZ-1][enerInd+1];
+	acoeff=(y2-y1)/(x2*x2-x1*x1);
+	bcoeff=y2-acoeff*x2*x2;
+	summ00=acoeff*logE*logE+bcoeff;
+	summ00 =exp(summ00);
+	y1=FTCSE[iZ-1][enerInd];
+	y2=FTCSE[iZ-1][enerInd+1];
+	acoeff=(y2-y1)/(x2*x2-x1*x1);
+	bcoeff=y2-acoeff*x2*x2;
+	summ10=acoeff*logE*logE+bcoeff;
+	summ10 =exp(summ10);
+      }
+    else  //Interpolation of the form y=ax+b
+      {  
+	x1=ener[104];
+	x2=ener[105];       
+	y1=TCSE[iZ-1][104];
+	y2=TCSE[iZ-1][105];
+	summ00=(y2-y1)*(logE-x1)/(x2-x1)+y1;
+	summ00 =exp(summ00);
+	y1=FTCSE[iZ-1][104];
+	y2=FTCSE[iZ-1][105];
+	summ10=(y2-y1)*(logE-x1)/(x2-x1)+y1;
+	summ10 =exp(summ10);
+      }
+    }
+  if(p==G4Positron::Positron())        
+    {
+    if(kinEnergy<=1.0e+9)
+      {
+	x1=ener[enerInd];
+	x2=ener[enerInd+1];       
+	y1=TCSP[iZ-1][enerInd];
+	y2=TCSP[iZ-1][enerInd+1];
+	acoeff=(y2-y1)/(x2*x2-x1*x1);
+	bcoeff=y2-acoeff*x2*x2;
+	summ00=acoeff*logE*logE+bcoeff;
+	summ00 =exp(summ00);
+	y1=FTCSP[iZ-1][enerInd];
+	y2=FTCSP[iZ-1][enerInd+1];
+	acoeff=(y2-y1)/(x2*x2-x1*x1);
+	bcoeff=y2-acoeff*x2*x2;
+	summ10=acoeff*logE*logE+bcoeff;
+	summ10 =exp(summ10);
+      }
+    else
+      {  
+	x1=ener[104];
+	x2=ener[105];       
+	y1=TCSP[iZ-1][104];
+	y2=TCSP[iZ-1][105];
+	summ00=(y2-y1)*(logE-x1)/(x2-x1)+y1;
+	summ00 =exp(summ00);
+	y1=FTCSP[iZ-1][104];
+	y2=FTCSP[iZ-1][105];
+	summ10=(y2-y1)*(logE-x1)/(x2-x1)+y1;
+	summ10 =exp(summ10);
+      }
+    }
     
-  if(p==G4Electron::Electron())        
-    {
-      MyValue= new G4DataInterpolation(ener,TCSEForThisAtom,106,0.0,0);  
-      InterpolatedValue = MyValue ->CubicSplineInterpolation(std::log(kineticE));
-      delete  MyValue;
-      summ00 = std::exp(InterpolatedValue);  
-      MyValue= new G4DataInterpolation(ener,FTCSEForThisAtom,106,0.0,0);  
-      InterpolatedValue = MyValue ->CubicSplineInterpolation(std::log(kineticE));
-      delete  MyValue;
-      summ10 = std::exp(InterpolatedValue);
-    }
-  if(p==G4Positron::Positron())        
-    {
-      MyValue= new G4DataInterpolation(ener,TCSPForThisAtom,106,0.0,0);  
-      InterpolatedValue = MyValue ->CubicSplineInterpolation(std::log(kineticE));
-      delete  MyValue;
-      summ00 = std::exp(InterpolatedValue);  
-      MyValue= new G4DataInterpolation(ener,FTCSPForThisAtom,106,0.0,0);  
-      InterpolatedValue = MyValue ->CubicSplineInterpolation(std::log(kineticE));
-      delete  MyValue;
-      summ10 = std::exp(InterpolatedValue);
-    }
-
   summ00 *=barn;
   summ10 *=barn;
@@ -374,7 +431,9 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
 //t->g->t step transformations taken from Ref.6 
-G4double G4GoudsmitSaundersonMscModel::ComputeTruePathLengthLimit(const G4Track& track,
-								  G4PhysicsTable* theTable,
-								  G4double currentMinimalStep)
+
+G4double 
+G4GoudsmitSaundersonMscModel::ComputeTruePathLengthLimit(const G4Track& track,
+							 G4PhysicsTable* theTable,
+							 G4double currentMinimalStep)
 {
   tPathLength = currentMinimalStep;
@@ -406,4 +465,9 @@
 
   G4double presafety = sp->GetSafety();
+
+  //G4cout << "G4GS::StepLimit tPathLength= " 
+  //	 <<tPathLength<<" safety= " << presafety
+  //       << " range= " <<currentRange<< " lambda= "<<lambda1
+  //	 << " Alg: " << steppingAlgorithm <<G4endl;
 
   // far from geometry boundary
@@ -437,4 +501,17 @@
           else  smallstep = 1.;
 
+          //define stepmin here (it depends on lambda!)
+          //rough estimation of lambda_elastic/lambda_transport
+          G4double rat = currentKinEnergy/MeV ;
+          rat = 1.e-3/(rat*(10.+rat)) ;
+          //stepmin ~ lambda_elastic
+          stepmin = rat*lambda1;
+          skindepth = skin*stepmin;
+          //define tlimitmin
+          tlimitmin = 10.*stepmin;
+          if(tlimitmin < tlimitminfix) tlimitmin = tlimitminfix;
+
+	  //G4cout << "rangeinit= " << rangeinit << " stepmin= " << stepmin
+	  //	 << " tlimitmin= " << tlimitmin << " geomlimit= " << geomlimit <<G4endl;
 	  // constraint from the geometry 
 	  if((geomlimit < geombig) && (geomlimit > geommin))
@@ -448,16 +525,4 @@
               tgeom = geombig;
 
-          //define stepmin here (it depends on lambda!)
-          //rough estimation of lambda_elastic/lambda_transport
-          G4double rat = currentKinEnergy/MeV ;
-          rat = 1.e-3/(rat*(10.+rat)) ;
-          //stepmin ~ lambda_elastic
-          stepmin = rat*lambda1;
-          skindepth = skin*stepmin;
-
-          //define tlimitmin
-          tlimitmin = 10.*stepmin;
-          if(tlimitmin < tlimitminfix) tlimitmin = tlimitminfix;
-
         }
 
@@ -471,4 +536,7 @@
 
       if(tlimit > tgeom) tlimit = tgeom;
+
+      //G4cout << "tgeom= " << tgeom << " geomlimit= " << geomlimit  
+      //      << " tlimit= " << tlimit << " presafety= " << presafety << G4endl;
 
       // shortcut
@@ -499,5 +567,5 @@
       if(tlimit < stepmin) tlimit = stepmin;
 
-      if(tPathLength > tlimit) tPathLength = tlimit  ; 
+      if(tPathLength > tlimit) tPathLength = tlimit; 
 
     }
@@ -519,22 +587,22 @@
 
       if((stepStatus == fGeomBoundary) || (stepStatus == fUndefined))
-      {
-        rangeinit = currentRange;
-        fr = facrange;
-        // 9.1 like stepping for e+/e- only (not for muons,hadrons)
-        if(mass < masslimite) 
-        {
-          if(lambda1 > currentRange)
-            rangeinit = lambda1;
-          if(lambda1 > lambdalimit)
-            fr *= 0.75+0.25*lambda1/lambdalimit;
-        }
-
-        //lower limit for tlimit
-        G4double rat = currentKinEnergy/MeV ;
-        rat = 1.e-3/(rat*(10.+rat)) ;
-        tlimitmin = 10.*lambda1*rat;
-        if(tlimitmin < tlimitminfix) tlimitmin = tlimitminfix;
-      }
+	{
+	  rangeinit = currentRange;
+	  fr = facrange;
+	  // 9.1 like stepping for e+/e- only (not for muons,hadrons)
+	  if(mass < masslimite) 
+	    {
+	      if(lambda1 > currentRange)
+		rangeinit = lambda1;
+	      if(lambda1 > lambdalimit)
+		fr *= 0.75+0.25*lambda1/lambdalimit;
+	    }
+
+	  //lower limit for tlimit
+	  G4double rat = currentKinEnergy/MeV ;
+	  rat = 1.e-3/(rat*(10.+rat)) ;
+	  tlimitmin = 10.*lambda1*rat;
+	  if(tlimitmin < tlimitminfix) tlimitmin = tlimitminfix;
+	}
       //step limit
       tlimit = fr*rangeinit;               
@@ -561,8 +629,11 @@
 	}
     }
+  //G4cout << "tPathLength= " << tPathLength  
+  // << " currentMinimalStep= " << currentMinimalStep << G4endl;
   return tPathLength ;
 }
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
+
 G4double G4GoudsmitSaundersonMscModel::ComputeGeomPathLength(G4double)
 {
@@ -602,5 +673,6 @@
       zmean = 1./(par1*par3) ;
   } else {
-    G4double T1 = theManager->GetEnergy(particle,currentRange-tPathLength,currentCouple);
+    G4double T1 = theManager->GetEnergy(particle,currentRange-tPathLength,
+					currentCouple);
 
     lambda11 = GetLambda(T1);
@@ -614,14 +686,14 @@
   zPathLength = zmean ;
   //  sample z
-  if(samplez)
-  {
+  if(samplez) {
+
     const G4double  ztmax = 0.99, onethird = 1./3. ;
     G4double zt = zmean/tPathLength ;
 
-    if (tPathLength > stepmin && zt < ztmax)              
-    {
+    if (tPathLength > stepmin && zt < ztmax) {
+
       G4double u,cz1;
-      if(zt >= onethird)
-      {
+      if(zt >= onethird) {
+
         G4double cz = 0.5*(3.*zt-1.)/(1.-zt) ;
         cz1 = 1.+cz ;
@@ -629,10 +701,9 @@
         G4double grej ;
         do {
-            u = exp(log(G4UniformRand())/cz1) ;
-            grej = exp(cz*log(u/u0))*(1.-u)/(1.-u0) ;
-           } while (grej < G4UniformRand()) ;
-      }
-      else
-      {
+	  u = exp(log(G4UniformRand())/cz1) ;
+	  grej = exp(cz*log(u/u0))*(1.-u)/(1.-u0) ;
+	} while (grej < G4UniformRand()) ;
+
+      } else {
         cz1 = 1./zt-1.;
         u = 1.-exp(log(G4UniformRand())/cz1) ;
@@ -642,11 +713,13 @@
   }
   if(zPathLength > lambda1) zPathLength = lambda1;
-
- return zPathLength;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
-
-G4double G4GoudsmitSaundersonMscModel::ComputeTrueStepLength(G4double geomStepLength)
+  //G4cout << "zPathLength= " << zPathLength << " lambda1= " << lambda1 << G4endl;
+
+  return zPathLength;
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
+
+G4double 
+G4GoudsmitSaundersonMscModel::ComputeTrueStepLength(G4double geomStepLength)
 {
   // step defined other than transportation 
@@ -673,4 +746,5 @@
     }
   if(tPathLength < geomStepLength) tPathLength = geomStepLength;
+  //G4cout << "tPathLength= " << tPathLength << " step= " << geomStepLength << G4endl;
 
   return tPathLength;
@@ -678,72 +752,71 @@
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
+//Total & first transport x sections for e-/e+ generated from ELSEPA code
+
 void G4GoudsmitSaundersonMscModel::LoadELSEPAXSections()
 { 
-  ///////////////////////////////////////
-  //Total & first transport x sections of e-/e+ from ELSEPA code
   G4String filename = "XSECTIONS.dat";
 
-    char* path = getenv("G4LEDATA");
-    if (!path)
-      {
-        G4String excep = "G4GoudsmitSaundersonTable: G4LEDATA environment variable not set";
-        G4Exception(excep);
-      }
-
-    G4String pathString(path);
-    G4String dirFile = pathString + "/msc_GS/" + filename;
-    FILE *infile;
-    infile = fopen(dirFile,"r"); 
-    if (infile == 0)
-      {
-	G4String excep = "G4GoudsmitSaunderson - data files: " + dirFile + " not found";
-	G4Exception(excep);
-      }
-
-    // Read parameters from tables and take logarithms
-    G4float aRead;
-    for(G4int i=0 ; i<106 ;i++){
-	  fscanf(infile,"%f\t",&aRead);
-          if(aRead > 0.0) aRead = std::log(aRead);
-          else  aRead = 0.0;
-          ener[i]=aRead;
+  char* path = getenv("G4LEDATA");
+  if (!path)
+    {
+      G4String excep = "G4GoudsmitSaundersonTable: G4LEDATA environment variable not set properly";
+      G4Exception(excep);
+    }
+
+  G4String pathString(path);
+  G4String dirFile = pathString + "/msc_GS/" + filename;
+  FILE *infile;
+  infile = fopen(dirFile,"r"); 
+  if (infile == 0)
+    {
+      G4String excep = "G4GoudsmitSaunderson - data files: " + dirFile + " not found";
+      G4Exception(excep);
+    }
+
+  // Read parameters from tables and take logarithms
+  G4float aRead;
+  for(G4int i=0 ; i<106 ;i++){
+    fscanf(infile,"%f\t",&aRead);
+    if(aRead > 0.0) aRead = log(aRead);
+    else  aRead = 0.0;
+    ener[i]=aRead;
+  }        
+  for(G4int j=0;j<103;j++){
+    for(G4int i=0;i<106;i++){
+      fscanf(infile,"%f\t",&aRead);
+      if(aRead > 0.0) aRead = log(aRead);
+      else  aRead = 0.0;
+      TCSE[j][i]=aRead;
     }        
-    for(G4int j=0;j<103;j++){
-      for(G4int i=0;i<106;i++){
-	  fscanf(infile,"%f\t",&aRead);
-          if(aRead > 0.0) aRead = std::log(aRead);
-          else  aRead = 0.0;
-	  TCSE[j][i]=aRead;
-	}        
-     }
-    for(G4int j=0;j<103;j++){
-      for(G4int i=0;i<106;i++){
-	  fscanf(infile,"%f\t",&aRead);
-          if(aRead > 0.0) aRead = std::log(aRead);
-          else  aRead = 0.0;
-	  FTCSE[j][i]=aRead;      
-	}        
-      }    
-    for(G4int j=0;j<103;j++){
-      for(G4int i=0;i<106;i++){
-	  fscanf(infile,"%f\t",&aRead);
-          if(aRead > 0.0) aRead = std::log(aRead);
-          else  aRead = 0.0;
-	  TCSP[j][i]=aRead;      
-	}        
-     }
-    for(G4int j=0;j<103;j++){
-      for(G4int i=0;i<106;i++){
-	  fscanf(infile,"%f\t",&aRead);
-          if(aRead > 0.0) aRead = std::log(aRead);
-          else  aRead = 0.0;
-	  FTCSP[j][i]=aRead;      
-	}        
-     }
-
-    fclose(infile);
-   //End loading XSections and Energies
-
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
+  }
+  for(G4int j=0;j<103;j++){
+    for(G4int i=0;i<106;i++){
+      fscanf(infile,"%f\t",&aRead);
+      if(aRead > 0.0) aRead = log(aRead);
+      else  aRead = 0.0;
+      FTCSE[j][i]=aRead;      
+    }        
+  }    
+  for(G4int j=0;j<103;j++){
+    for(G4int i=0;i<106;i++){
+      fscanf(infile,"%f\t",&aRead);
+      if(aRead > 0.0) aRead = log(aRead);
+      else  aRead = 0.0;
+      TCSP[j][i]=aRead;      
+    }        
+  }
+  for(G4int j=0;j<103;j++){
+    for(G4int i=0;i<106;i++){
+      fscanf(infile,"%f\t",&aRead);
+      if(aRead > 0.0) aRead = log(aRead);
+      else  aRead = 0.0;
+      FTCSP[j][i]=aRead;      
+    }        
+  }
+
+  fclose(infile);
+
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/source/processes/electromagnetic/standard/src/G4GoudsmitSaundersonTable.cc
===================================================================
--- trunk/source/processes/electromagnetic/standard/src/G4GoudsmitSaundersonTable.cc	(revision 1058)
+++ trunk/source/processes/electromagnetic/standard/src/G4GoudsmitSaundersonTable.cc	(revision 1196)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4GoudsmitSaundersonTable.cc,v 1.1 2009/03/05 18:48:30 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
+// $Id: G4GoudsmitSaundersonTable.cc,v 1.4 2009/08/28 16:36:52 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 // -------------------------------------------------------------------
@@ -39,4 +39,6 @@
 // Modifications:
 // 04.03.2009 V.Ivanchenko cleanup and format according to Geant4 EM style
+// 26.08.2009 O.Kadri: avoiding unuseful calculations and optimizing the root finding parameter error's 
+//                     within SampleTheta method
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -167,12 +169,16 @@
   0.996273,0.997261,0.998097,0.998782,0.999315,0.999695,0.999924,1.0};
 
-G4double G4GoudsmitSaundersonTable::PDF[]  = {-1.};
-G4double G4GoudsmitSaundersonTable::CPDF[] = {-1.};
+G4double* G4GoudsmitSaundersonTable::PDF  = 0;
+G4double* G4GoudsmitSaundersonTable::CPDF = 0;
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
 G4GoudsmitSaundersonTable::G4GoudsmitSaundersonTable()
 {
-  if(PDF[0] < 0.0){ 
+  if(PDF == 0){ 
     G4cout << "### G4GoudsmitSaundersonTable loading PDF data" << G4endl;
+
+    PDF = new G4double [76*11*320];
+    CPDF= new G4double [76*11*320];
+
     LoadPDFandCPDFdata();
   }
@@ -181,5 +187,11 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
 G4GoudsmitSaundersonTable::~G4GoudsmitSaundersonTable()
-{}
+{
+  if(PDF) {
+    delete [] PDF;
+    delete [] CPDF;
+    PDF = 0;
+  }
+}
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -194,7 +206,7 @@
   ///////////////////////////////////////////////////////////////////////////
   // Find Lambda and Chia2 Index
-  for(G4int k=0;k<75;k++){if((lambda>=LAMBDAN[k])&&(lambda<LAMBDAN[k+1]))KIndex=k;}  
+  for(G4int k=0;k<75;k++){if((lambda>=LAMBDAN[k])&&(lambda<LAMBDAN[k+1])){KIndex=k;break;}}  
   for(G4int j=0;j<11;j++){A[j]=scrA[11*KIndex+j];}  
-  for(G4int j=0;j<10;j++){if((Chia2>=A[j])&&(Chia2<A[j+1]))JIndex=j;}
+  for(G4int j=0;j<10;j++){if((Chia2>=A[j])&&(Chia2<A[j+1])){JIndex=j;break;}}
 
   ///////////////////////////////////////////////////////////////////////////
@@ -218,12 +230,13 @@
     ThisPDF[i]=Ckj*PDF1[i]+CkjPlus1*PDF2[i]+CkPlus1j*PDF3[i]+CkPlus1jPlus1*PDF4[i];
     ThisCPDF[i]=Ckj*CPDF1[i]+CkjPlus1*CPDF2[i]+CkPlus1j*CPDF3[i]+CkPlus1jPlus1*CPDF4[i];  
+  // Find u Index using secant method
+  if((i!=0)&&((rndm>=ThisCPDF[i-1])&&(rndm<ThisCPDF[i])))  {IIndex=i-1;break;}
   }
 
   ///////////////////////////////////////////////////////////////////////////
-  // Find u Index using secant method
-  for(G4int i=0;i<319;i++){if((rndm>=ThisCPDF[i])&&(rndm<ThisCPDF[i+1]))IIndex=i;}
   //CPDF^-1(rndm)=x ==> CPDF(x)=rndm;
   aa=uvalues[IIndex];
   b=uvalues[IIndex+1];
+  
   do{
     m=0.5*(aa+b);
@@ -233,5 +246,5 @@
     if(F>0.)b=m;
     else aa=m;
-  } while(sqrt((b-aa)*(b-aa))>1.0e-10);
+  } while(sqrt((b-aa)*(b-aa))>1.0e-6);
 
   return m;
